﻿using System;
using System.Linq;
using System.Windows;
using Telerik.Windows.DragDrop;
using System.Windows.Controls;
using Telerik.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DragDropManager.AddDragInitializeHandler(xToolBar1, OnDragInitialize);
            DragDropManager.AddGiveFeedbackHandler(xToolBar1, OnGiveFeedback);

            DragDropManager.AddDragInitializeHandler(xToolBar2, OnDragInitialize);
            DragDropManager.AddGiveFeedbackHandler(xToolBar2, OnGiveFeedback);

            DragDropManager.AddDragInitializeHandler(xToolBar3, OnDragInitialize);
            DragDropManager.AddGiveFeedbackHandler(xToolBar3, OnGiveFeedback);

            DragDropManager.AddDragInitializeHandler(xToolBar4, OnDragInitialize);
            DragDropManager.AddGiveFeedbackHandler(xToolBar4, OnGiveFeedback);

            DragDropManager.AddDropHandler(xToolBarTray, OnTrayBarDrop);
            DragDropManager.AddDropHandler(border, OnBorderDrop);
        }

        private void OnDragInitialize(object sender, DragInitializeEventArgs args)
        {
            args.AllowedEffects = DragDropEffects.All;
            var payload = DragDropPayloadManager.GeneratePayload(null);
            payload.SetData("DragData", args.OriginalSource);
            args.Data = payload;
            args.DragVisual = (args.OriginalSource as RadToolBar).Name;
        }

        private void OnGiveFeedback(object sender, Telerik.Windows.DragDrop.GiveFeedbackEventArgs args)
        {
            args.SetCursor(Cursors.Arrow);
            args.Handled = true;
        }
        private int currentBandsCount = 2;
        private void OnTrayBarDrop(object sender, Telerik.Windows.DragDrop.DragEventArgs args)
        {
            RadToolBar draggedToolBar = ((DataObject)args.Data).GetData("DragData") as RadToolBar;

            if ((args.Source as FrameworkElement).ParentOfType<RadToolBar>() != null)
            {
                RadToolBar toolBar = (args.Source as FrameworkElement).ParentOfType<RadToolBar>();

                draggedToolBar.Band = toolBar.Band;
                draggedToolBar.BandIndex = toolBar.BandIndex + 1;

                xToolBarTray.Items.Refresh();
            }
            else
            {

                RadToolBarTray tray = (args.OriginalSource as UIElement).ParentOfType<RadToolBarTray>();

                if (tray != null)
                {
                    Point dropPoint = args.GetPosition(tray);
                    var hitTest = VisualTreeHelper.HitTest(tray, new Point(0, dropPoint.Y));
                    if ((hitTest.VisualHit as UIElement).ParentOfType<RadToolBar>() != null)
                    {
                        RadToolBar toolBar = (hitTest.VisualHit as UIElement).ParentOfType<RadToolBar>();

                        draggedToolBar.Band = toolBar.Band;
                        draggedToolBar.BandIndex = toolBar.BandIndex + 1;
                    }
                }
                else
                {
                    draggedToolBar.Band = currentBandsCount;
                    draggedToolBar.BandIndex = 0;
                    currentBandsCount++;
                }
                xToolBarTray.Items.Refresh();
            }
        }
        private void OnBorderDrop(object sender, Telerik.Windows.DragDrop.DragEventArgs args)
        {
            RadToolBar draggedToolBar = ((DataObject)args.Data).GetData("DragData") as RadToolBar;
            draggedToolBar.Band = currentBandsCount;
            draggedToolBar.BandIndex = 0;
            currentBandsCount++;

            xToolBarTray.Items.Refresh();
        }
    }
}
